CHANGELOG FOR EMULE SPIKE2-MOD
==============================


_____________________________________________
|crazy - funky - as fast as "Speedy the cat"|
---------------------------------------------
|   Whatever you do - you can't stop the    |
|              CLIENT-ANALYZER              |
---------------------------------------------



Spike2 1.2
----------
-->NOTE: As people often mix things up, here I state it once and for all: Spike2-Mod IS NOT based on the emulefuture-Mod. The
         emulefuture-Mod IS NOT based on Spike2-Mod, either...!
ADDED  : Added more AICH security checks and request AICH hashes only in case we don't have a valid hash, yet (by WiZaRd, from
         the emulefuture-Mod)
ADDED  : Added PaddingLength to Extended preferences (Xman)
ADDED  : Addon-Directory (by Shadow/WiZaRd, taken from the emulefuture-Mod) -> Readded !!
ADDED  : Automatic IPfilter-updates, incl. Update via ed2k (by Morph, WiZaRd and Shadow2004 - taken from the emulefuture-Mod)
ADDED  : Automatic Shared files updater (by MoNKi, taken from ScarAngel)
ADDED  : Better passive source finding (by Xman, taken from X-Ray)
ADDED  : Cache UDP Search Results (by Slugfiller, taken from X-Ray)
ADDED  : CompatClientStats (is a nice AddOn to my EnhancedClientRecognization, by Stulle, taken from X-Ray)
ADDED  : Copy feedback to clipboard (by WiZaRd, taken from the emulefuture-Mod // requested by Teac2, vannelle, Crimson and many others)
ADDED  : Don't overwrite .bak-files (by Xman, taken from X-Ray)
ADDED  : Don't send empty directorys (by WiZaRd from the emulefuture-Mod)
ADDED  : Extra-UserInfos in UploadListCtrl (from MorphXT)
ADDED  : HashProgress (O2, taken from X-Ray)
ADDED  : Inform queued clients after IP/ID-change (by Stulle, taken from StulleMule; modified by Spike2 to work without "Optimization
         Requpfile")
ADDED  : LinearPriority (as part of SCC, by MoNKi, modified by Stulle and taken from ScarAngel)
ADDED  : MassRename (from Morph, taken from ScarAngel // requested by Crimson)
ADDED  : OnlineSig-Optimization (by JvA)
ADDED  : Queued flush threads (by Xman, taken from X-Ray)
ADDED  : Part-completion speedup (by BlueSonicBoy, taken from X-Ray-Mod)
ADDED  : SCC - Smart Category Control (by khaos, SiRoB and Stulle, taken from ScarAngel // requested by Crimson and TreviSyn)
ADDED  : Simple CleanUp (MorphXT, taken from ScarAngel - added as part of MassRename)
ADDED  : WiZaRd's AutoHL (=AutoHardLimit, taken from the emulefuture-Mod, Thanx @ WiZaRd for pointing out my stupid typos in the prefs !)
BUGFIX : AICHSyncThread - prevent crash when shutting down (by Xman)
BUGFIX : As usual many small optimizations from various mods (i.e. Morph, emulefuture, X-Ray, Xtreme ...)
BUGFIX : Changed some functions in otherfunctions.cpp (by WiZaRd from the emulefuture-Mod)
BUGFIX : CheckDiskSpace-Fix (by Slugfiller, taken from X-Ray)
BUGFIX : CorruptionBlackBox-Fix (by Xanatos, taken from ScarAngel)
BUGFIX : CrashFix in sockets.cpp (by Maella, taken from X-Ray)
BUGFIX : Do not ask exit from command prompt (by XMan)
BUGFIX : DoubleLucas (by Slugfiller, taken from X-Ray)
BUGFIX : FixConnectionCollision - added some more code (taken from X-Ray)
BUGFIX : (Hopefully) Fixed SourceCache (thanx to JvA)
BUGFIX : IP2country small fixes (by WiZaRd)
BUGFIX : Loop-improvement in CListenSocket::Process (taken from X-Ray, original by WiZaRd)
BUGFIX : Optimization in DownloadQueue (by WiZaRd, taken from the emulefuture-Mod)
BUGFIX : PeerCache-Bugfix in StatisticsDlg (by Xman)
BUGFIX : Quickfix against division through zero in Taskbar Notifier (Xman)
BUGFIX : Reload shared files on filenotfound exception (Xman)
BUGFIX : SafeHash compatibility fix in KnownFile (by Xman)
CHANGED: eMulePlus is informed instead of reasked after IP-change, too (Spike2 - I read e+-sources and saw that they can handle an
         "inform", too - so we can save the reask here!)
CHANGED: Rearranged the Mod-Prefs :) (Spike2)
CHANGED: ULS - removed typo ;) (thanx to trax69)
UPDATED: Dynamic Block Requests (some changes, partly due to PartCompletionSpeedUp, taken from X-Ray / Original by netfinity &
         BlueSonicBoy)
UPDATED: Major update of the SLS-code (by WiZaRd, taken from the emulefuture-Mod)
UPDATED: Some small changes in ReadBlockFromFileThread (by SiRoB, taken from X-Ray)
UPDATED: TabbedPrefs (Original by TPT, taken from X-Ray-Mod) to "Reworked TabbedPrefs" by shadow2004 (from the emulefuture-Mod)


Spike2 1.1 - interims Release....
---------------------------------
-->CODEBASE: Updated to eMule 0.48a
-->Happy Birthday, eMule ;-)
-->NOTE: This is just an "interims release" for all Spike2-Mod-users to give them the possibility to use 0.48a-based-Spike2. Many planned
         features haven't been inserted, one empty PrefPage & one known bug - but it works as good as old Spike2 1.0.
         Known bug: When you select a Payback First option, "Try to upload full chunks" selection removes. This is just an optical bug,
         the settings are correctly applied.
ADDED  : Netfinity's Fakealyzer (taken from netF's WARP-Mod) - can be turned on / off on "Look'n'feel"-page in ModOptions
ADDED  : Renew UPnP-Port-Mappings after IP-change (Spike2)
ADDED  : ReqBlocksClipping (by Slugfiller, taken from X-Ray-Mod)
ADDED  : SourceCache (by Xman, taken from SilverSurfer; Modifications & AddOns by Spike2)
BUGFIX : Assert fix for radio in TreeOptionsCtrl.cpp (Stulle, taken from ScarAngel)
BUGFIX : Fix for enable/disable ClientList / QueueList (by Xman, see: http://forum.emule-project.net/index.php?showtopic=124852)
BUGFIX : ICS - Incomplete parts information is sent even if we turn off ICS (so turning ICS on/off just changes the way WE choose
         the next chunk)
BUGFIX : Kad Message Bounce Protection (by netfinity, see: http://forum.emule-project.net/index.php?showtopic=124655)
BUGFIX : Optimization in SharedFileList by leuk_he (from MorphXT)
BUGFIX : SLS: don't save obfuscation required sources (would need to also store the userhash) (by Xman, taken from Xtreme 6.0b1)
BUGFIX : Some small changes, fixes and patches from various mods (i.e. emulefuture, netF WARP, XRay, etc.)
BUGFIX : Vista-Fix for IP2Country (by Shadow from emulefuture-Mod)
BUGFIX : Wrong null userhash test (by ilmira, see: http://forum.emule-project.net/index.php?showtopic=124766)
CHANGED: Small changes in SLS, "Don't kill source"-features, etc. - all related due to the removing of WebCache
CHANGED: SR13-ImportParts-feature to Morph-implementation (by MorphXT 10.0, taken from StulleMule 5.0)
CHANGED: UploadQueue-Cycles (taken from netF's WARP-Mod)
REMOVED: AddOn-Directory (will be readded !)
REMOVED: UPnP-Support (emf-implementation removed due to 0.48a-Merge)
REMOVED: Vista-/Windows2003-fix in otherfunctions.cpp (not needed anymore due to 0.48a-Merge)
REMOVED: WebCache (because nowadays it's only used for ABusing open proxies...and has therefore begun to become a serious security
         issue !)
UPDATED: Small changes in extractfile.cpp (by WiZaRd, from the emulefuture-Mod)


Spike2 1.0
----------
ADDED  : Add next connect theft - logging (from netF's WARP-Mod)
ADDED  : AddOn-Directory (by Shadow/WiZaRd, taken from the emulefuture-Mod)
ADDED  : Anti-HideOS (optimizes ICS; taken from iONiX 4.4, updated & implemented by Spike2 - might be updated to emulefuture's
         implementation later)
ADDED  : Better treatment of some mods (Spike2, ideas from WiZaRd)
ADDED  : ClientPercentage (by SLAHAM, taken from MorphXT; Feature request from Mauro)
ADDED  : Credits Reset Exploit Prevention (netfinity, taken from netF-WARP)
ADDED  : DVD-Files aren't cleaned up by the Filename-CleanUp-function (FiX by BlueSonicBoy from TK4-Mod)
ADDED  : eMulePlus has a ReaskTime of 28 instead of 29 minutes, so the ReaskTime for them is 28 minutes now ! (Spike2)
ADDED  : Extra-cool MiniMule-eye-candy by WiZaRd (taken from the emulefuture-Mod)
ADDED  : ICS (Original by enkeyDev, taken from the emulefuture-Mod)
ADDED  : Inform sources of an ID-change: eMule-/eDonkey(Hybrid)-Sources will be informed with the OP_CHANGE_CLIENT_ID-opcode of an 
         ID-change, all other clients will be reasked as usual, because we can't know, if they support the OP_CHANGE_CLIENT_ID-opcode                  (ALL sources will be REASKED if we are on a LowID; NeoMule & parts from Spike2)
ADDED  : IP2Country (Original by Commander/Eastshare, taken from the emulefuture-Mod) --> WITH WiZaRd's FileOrigin-AddOn (taken from
         the emulefuture-Mod) and IP2Country-to-ProxyClient (taken from MorphXT)
ADDED  : Known Clients Bonus (from netF-WARP, switchable in "Upload Management"-PrefPage)
ADDED  : Links in NetworkInfoDlg (Spike2, inspired by Xtreme)
ADDED  : LowID2HighID-AutoCallback (L2HAC; Original by eMule+ (?), taken from NeoMule)
ADDED  : ML-Donkey's XS-Packets are now correctly recognized in ListenSocket.cpp (Spike2; full support will be added later,
         ideas & hints from WiZ)
ADDED  : "Obfuscated connection to server required" preference (leuk_he, taken from the newest MorphXT)
ADDED  : PaybackFirst (WiZaRd's Implementation, taken from the emulefuture-Mod)
ADDED  : PrefSlider (Original by eMule+, taken from X-Ray-Mod)
ADDED  : Safe KAD, incl. Kad-Anti-fragmenting (by netfinity and optimized by WiZaRd, taken from the emulefuture-Mod)
ADDED  : SearchCatch (Slugfiller, taken from the emulefuture-Mod)
ADDED  : SearchColours (WiZaRd, taken from the emulefuture-Mod)
ADDED  : Send protocol-extensions only to supporting clients to save overhead (idea from MorphXT, taken from the emulefuture-
         mod and modified by Spike2) --> used for ModString, Webcache, L2HAC and ICS
ADDED  : Show Compression in UploadListCtrl (Tarod/MorphXT, taken from the X-Ray-Mod)
ADDED  : Show 'Download added' in TransferWindow (netfinity)
ADDED  : Some AddOns in CommentsListCtrl (from MorphXT)
ADDED  : SR13-Import-Parts function can be stopped now (by CiccioBastardo from CB-Mod)
ADDED  : Support-Links, Server.met-Updating (Support-links inspired by Xtreme, Server.met-Updating taken from the emulefuture-Mod)
ADDED  : TabbedPrefs (Original by TPT, taken from X-Ray-Mod)
ADDED  : Understand Crumbs- & TheHorde-opcodes (just for the verbose-log, taken from netfinity's WARP-MOD)
ADDED  : UPnP-Support (with Windows-Service-Startup by WiZaRd) (taken from the emulefuture-mod, WiZaRd's / Shadows
         implementation)
BUGFIX : ClientAnalyzer-switchable: fixed bug in UploadClient.cpp (in combined FilePrio and Credit the Analyzer was always used)
BUGFIX : Collection double extension (by CiccioBastardo, taken from the MorphXT-Mod)
BUGFIX : Correct SUI-stats (by WiZaRd, taken from the emulefuture-mod)
BUGFIX : Enhanced Client Recognization - some transferdata wasn't counted - Bugfix by Stulle
BUGFIX : Fix Connection Collision (from MorphXT)
BUGFIX : Fixed a bug in SLS, which caused SLS to not save sources (reported by Frawe, fix by JvA !)
BUGFIX : Improved BanCheck (from Sivka)
BUGFIX : Many fixes and optimizations from the emulefuture-mod, mainly by WiZaRd
BUGFIX : Small changes in Webcache (from newest MorphXT)
BUGFIX : Small fix in WebcacheClient.cpp (Spike2 - fixed timeout-values)
BUGFIX : Some fixes and optimizations from various mods (tagged in the code, i.e. MorphXT, ZZUL BastarD, Sivka-Mod, Xtreme, WARP, etc.)
BUGFIX : UDP Reask sequrity check - Don't accept responses if we haven't asked (by netfinity, from netF-WARP)
BUGFIX : Vista-/Windows2003-fix in otherfunctions.cpp (from MorphXT)
BUGFIX : WiZaRd's Fix for unfair client treatment (http://forum.emule-project.net/index.php?showtopic=116699)
BUGFIX : WiZaRd's Missing-Code-fix in ListenSocket (taken from the emulefuture-Mod)
BUGFIX : WiZaRd's Optimization in LastCommonRouteFinder (taken from the emulefuture-Mod)
BUGFIX : WiZaRd's Respect SoftLimit (taken from the emulefuture-Mod)
CHANGED: ConChecker will be used in Webcache.cpp, too (Spike2)
CHANGED: Raised Webcache-Blocklist-size (by WiZaRd; 2000 --> 10000)
CHANGED: Some default settings
CHANGED: XMan's Reconnect Kad on IP-change to --> Reset Kad-IP on IP-Change (by WiZaRd)
REMOVED: Ban "CrashMules" (not needed anymore)
REMOVED: Dazzle's Create Map (buggy in the princip, so it can't be fixed)
REMOVED: netfinity's DownloadThrottler (was added with WebCache, reverted back to original code / Spike2)
UPDATED: Aux-ports-support by lugdunummaster (from newest MorphXT)
UPDATED: ClientAnalyzer (WiZaRd)
UPDATED: Code-Improvements in CUint128::toBinaryString & toHexString (by netfinity, modified by WiZaRd, taken from the emulefuture-Mod)
UPDATED: ConChecker (by WiZaRd)
UPDATED: Don't kill client / source - features (from MorphXT)
UPDATED: Dynamic Block Requests (by netfinity, taken from netF-WARP) - Download from eDonkey/eDonkeyHybrid should be a bit better now
UPDATED: Emulate Shareaza (just a small adjustment; Spike2)
UPDATED: Extra Kad-Logging (from MorphXT 9.0) to WiZaRd's Anti-Fake-IP (from the emulefuture-Mod)
UPDATED: "Initiate Rehash"-function updated according to the newest code in 0.47c-Partfile.cpp (by Spike2, thanks WiZaRd)
UPDATED: ModIconMapper to the updateable new version (Shadow/WiZaRd, taken from the emulefuture-Mod)
UPDATED: ReadBlockFromFileThread (from netF-WARP 0.3)
UPDATED: SafeHash and FlushThread (from netF-WARP 0.3 and MorphXT 9.5; thanx to JvA for pointing out a bug)
UPDATED: Show Userhash in MyInfo (by WiZaRd, from the emulefuture-Mod)
UPDATED: SR13-Import-Parts (updated from the CB-Mod, "Stop import" by CiccioBastardo, threading code by Sirob)
UPDATED: UltraLeecherSecure (for those who still use it: made same NickName-checks case-sensitive, to avoid banning of innocent clients)
UPDATED: WiZaRd's Missing Buddy Check (taken from the emulefuture-Mod)


Spike2 0.9
----------
ADDED  : IntelliFlush (by WiZaRd, from the emulefuture-Mod) --> can be turned on/off in the Tweaks-PrefPage
ADDED  : ModIconMapper (by WiZaRd, from the emulefuture-Mod) with many new ModIcons & ModStrings (added by Spike2)
ADDED  : Powershare (WiZaRd's Implementation from Tombstone-Mod)
         -->NOTE: Powershare on partfiles isn't possible. (disabled by Spike2)
ADDED  : Prevent USS-Spam (by WiZaRd)
ADDED  : QRETA (by Slugfiller, taken from emulefuture-Mod)
ADDED  : Save Friendupload-Slot (by WiZaRd, from Tombstone-Mod)
ADDED  : Security-Patch in ListenSocket.cpp (by WiZaRd, taken from the emulefuture-Mod)
ADDED  : Server-Message-Filter (by WiZaRd, taken from the emulefuture-Mod)
ADDED  : SharedView Ed2kType (by Avi3k and WiZaRd, taken from the emulefuture-Mod)
ADDED  : ShowQDifference (by itsonlyme from SF-IOM, taken from emulefuture-Mod)
ADDED  : SpreadReask deactivated for Xtreme-Mods (Spike2)
BUGFIX : AntiCorruption - fixed by WiZaRd (could cause files to "hang" at 99,9 %)
BUGFIX : Context-Fix in ChatSelector (by WiZaRd)
BUGFIX : Crash-Bug in MMSocket - Fix by XMan
BUGFIX : Enhanced Client Recognization: Fix in recognizing eMulePlus-Version
BUGFIX : Protocol-Obfuscation: Small fixes (i.e. Connect, show port // by WiZaRd)
BUGFIX : SafeHash - Memleak-Fix by WiZaRd
BUGFIX : Several small fixes and optimizations from WiZaRd's Tombstone-Mod and from the emulefuture-Mod
BUGFIX : XS-Workaround / Fix (by WiZaRd & Xanatos)
CHANGED: Colours in file-status (by Xman from Xtreme; Feature request from Blomy)
CHANGED: Dynamic Block Requests: Small changes by WiZaRd (taken from Tombstone-Mod)
CHANGED: First Start maximized (by WiZaRd, taken from the emulefuture-Mod)
CHANGED: Friendslot-behaviour when VQB-FullChunk is selected (now more than one chunk is transferred, Spike2)
CHANGED: SLS: LowID-sources are saved, too - except we are a LowID-client ourself ! (Spike2)
CHANGED: Show active downloads in bold (setting applies immediately and doesn't need a restart any longer - changes
         by Shadow2004 and WiZaRd, taken from the emulefuture-Mod)
CHANGED: Small redesign of the "Security-Options"-page to make it easier for the user
REMOVED: AntiCreditHack (useless, because CreditHacks are already handled by official code // Spike2)
REMOVED: Don't show Splashscreen on old Windows to avoid crash (from Xtreme Mod) --> not needed with Standard-Splash
REMOVED: MSS-Setting (not used in Spike2-Mod, if it will ever be used by official codebase, your chosen MTU-value minus 40
         will be used as MSS-Setting (Spike2)
UPDATED: Reconnect Kad on IP-Change by XMan (from Xtreme)
UPDATED: Some parts of the ClientAnalyzer (by WiZaRd) - XS-Spammers are now correctly punished


Spike2 0.8
----------
-->CODEBASE: Updated to eMule 0.47c
-->CODEBASE: Merged with netF's ESE 1.0b-Mod (nearly complete merge), @netF: PLEASE KEEP UP THE GOOD WORK !!!!
-->CODEBASE: Added WiZaRd's ingenious ClientAnalyzer from Tombstone-Mod...a great piece of work. THANX WIZARD !!!!
==>NOTE: This release should be the right one for all Webcache-Users :-) Big thanx @ maloXP for his good thoughts and
         feature requests about Webcache. Please test the changes and post stats @ http://www.emulefuture.eu !!
==>THANX FLY OUT TO MY BETA-TESTERS (listed in no special order): Jojo, magicm13, GrafBerg, ChrisCornell, Blomy, emulefan83
==>THANX FOR HELPFULL COMMENTS TO (listed in no special order): eMuleGott, WiZaRd, JvA, Xman
ADDED  : AntiShape (by netfinity, taken from ESE-Mod 1.0b)
ADDED  : Automatic AntiLeecher-Options-Check (prevents using incompatible settings; by Spike2)
ADDED  : *** ClientAnalyzer 1.4ß from TombStone 1.55RC by WiZaRd...@ WiZ: Great work, thanx for this !! ***
ADDED  : Dynamic Block Requests (by netfinity, taken from ESE-Mod 1.0b)
ADDED  : Extra Kad-Logging (from MorphXT 9.0)
ADDED  : Flush Thread (by SiRoB from MorphXT, taken from netfinity's ESE-Mod 1.0b)
ADDED  : Forgot to mention in older changelogs: Enabled STRG+F in Transferwindow
ADDED  : Full Chunk Upload switchable: None, Official- or VQB-method (Spike2, VQB's FullChunk taken from Tombstone 1.55RC) -
         You can even switch during running upload-sessions :) !
ADDED  : Infinite Queue (by Slugfiller, from SF-IOM)
ADDED  : MessageFlash (by Slugfiller, from SF-IOM)
ADDED  : ReadBlockFromFileThread (by SiRoB from MorphXT, taken from netfinity's ESE-Mod 1.0b)
ADDED  : Reask sources after IP-change v2 (idea by Xman, first coded by maella, recoded by Stulle, changed for Spike2-Mod by Spike2, 
         taken from StulleMule 4.0)
ADDED  : SafeHash (by Slugfiller, taken from netfinity's ESE-Mod 1.0b)
ADDED  : Show ModVer in Queuelist (by WiZaRd, from Tombstone 1.55RC)
ADDED  : Show related source coloured (by WiZaRd, from Tombstone 1.55RC)
ADDED  : SlotFocus (very simple variant, Spike2)
ADDED  : Variable compression - switchable in "Upload Management" (reduces CPU usage at high upload rates; by netfinity, 
         taken from ESE 1.0b)
ADDED  : Webcache-Statistic (from MorphXT 9.0)
BUGFIX : Cleaned up the code here and there :)
BUGFIX : Countless fixes and optimizations from WiZaRd, incl. CPU-Saving fixes (mostly from Tombstone 1.55RC)
BUGFIX : ECR: Bugfix in EmulePlus-Version-detection (by Eniq)
BUGFIX : ECR & Emulates: Fixes in detecting and emulating MLdonkey (WiZaRd), Small fix in emulating (Spike2)
BUGFIX : Various fixes from various mods :)
BUGFIX : "Webcache & eMule > 0.47b"-Fix by Aireoreion from iONiX-Mod - THANX !!
CHANGED: Better Tagging in the code (Spike2)
CHANGED: Emulate MLdonkey (small change, Spike2)
CHANGED: FileBufferSize max. is now 15,5 MB again
CHANGED: FileBufferTimeLimit may be increased up to 20 minutes (instead of 10 minutes)
CHANGED: Forgot to mention in 0.7er Changelog: Merged changelog entries for Spike2 0.6 BETA1, BETA2 and Final
CHANGED: Small Addon in XMan's compression evaluation in AbstractFile.cpp (Spike2)
CHANGED: Some preferences-defaults (Spike2)
CHANGED: Some small changes around Spooky-Mode's ConChecker (from Cyrex2001-Mod)
CHANGED: Standard-Nick
CHANGED: Webcache changes inspired by maloXP: 
         * Webcache-capable sources - with the same proxy as we use - aren't dropped by the DropSources feature (can be switched on 
           or off in the Download Management; Spike2)
         * enhanced the little "Webcache-Addon" from v0.1 (Spike2)
         * Maximum proxy connections raised from 10 to 15 (Spike2)
         * Threshold for temporary webcache-desactivation raised from 100 to 200 not successful requests (Spike2)
REMOVED: Avi-3k's Fix for new message log entry (not needed with ClientAnalyzer)
REMOVED: Dazzle's Faster Endgame (DFE) (due to implementation of netfinity's Dynamic Block Requests - Spike2)
REMOVED: GetClosestTo-Kad-Patch from Unknown1 - implemented in 0.47b
REMOVED: "Releaser-Options"-Preferences Page (makes no sense at all, the planned options will move to the "Upload
         Management"-page)
REMOVED: Webcache-Trustlevel-changes...now back to standard (Spike2)
REMOVED: XMans Chunk selection patch (not needed for 0.47b+)
UPDATED: WebCache updated to MorphXT 9.0-codebase (Spike2)
UPDATED: WiZaRd's Automatic Kademlia Firewall Retries (from Tombstone 1.55RC)
UPDATED: WiZaRd's Relax on Startup (from Tombstone 1.55RC)


Spike2 0.7
----------
-->CODEBASE: Updated to eMule 0.47a
==>NOTE: BIG THANX FLY OUT TO ALL BETA-TESTERS, WHO HELPED ME WITH THIS VERSION. GUYS, YOU ARE GREAT !! Beta-Testers
         are (in alphabetical order): Abyss K3 IC, GrafBerg, hackersondope2002, Hausi GER. (retired), magicm13, 
         Sh0ck3r, Smoke and sWub/Poolitzer.
         And BIG THANX @ WiZaRd for answering many, many questions and giving helpful hints and tipps...!!!
ADDED  : Activation Limit for the Drop Sources System (Spike2)
ADDED  : Checkbox for using the new HighResTimer by zz (to be found in the "Extended Settings") (Spike2)
ADDED  : "Dazzle's Map" can be turned on or off now (Spike2)
ADDED  : Drop Sources System with Timer for FQ, HQR & NNP (taken from Sion, slightly modified) enhanced with the LODATI;
         DropSources feature recommended / requested by GrafBerg & magicm13
ADDED  : ListenSocket.cpp: OP_REQUESTFILENAME isn't answered for banned clients (from eMulePlus, changed by
         Spike2 to avoid calling IsBanned())
ADDED  : List of don't ask these IPs (for Drop System, taken from Cyrex-Mod; original by Sivka)
ADDED  : Logging options for the new features (Spike2)
ADDED  : Multiple Instances (from iONiX, taken from Resurrection; request from Poolitzer/sWub)
ADDED  : SLS - Sources Loader/Saver (Original from enkeyDEV, taken from the Sion-Mod, modified by Spike2 - with big
         Thanx to WiZaRd !!)
ADDED  : Spooky-Mode, incl. ConChecker, rule-compliant (Original from eWombat, modified by Fenderman, taken 
         from Cyrex2001, Rule-Compliance by WiZaRd <-- Thanx to all of you :-) !)
ADDED  : Show Spooky-Connect icon in Statusbar and MiniMule - I think it looks better now... (by Spike2, 
         Tag: SpookyConnIcon)
BUGFIX : Code-Improvement in DownloadClient.cpp regarding the UDPReaskForDownload() (by Loulach, taken from Sion)
BUGFIX : Control for showing active downloads in bold: Setting was not saved (Bug found by magicm13)
BUGFIX : GetClosestTo-Kad-Patch from Unknown1
BUGFIX : FileDetailDialogInfo-Patch (thx to Sirob, taken from StulleMule)
BUGFIX : Prevent switch to ... busy popup during windows startup (by leuk_he, taken from Cyrex2001)
BUGFIX : Small Fix around server.met-handling & -updating (Bug found by Poolitzer)
BUGFIX : Some small fixes for the SR13-Import-Parts-feature (incl. "Initiate Rehash") from iONiX 4.4
BUGFIX : Some small fixes from MorphXT
BUGFIX : Some small Webcache-Fixes & -Changes (from iONiX)
BUGFIX : The Hardlimit was not always obeyed (Bug first reported by pivi33)
CHANGED: Anti-CreditHack (optimized, thanx to WiZaRd)
CHANGED: Enhanced Client Recognization: added some Compatible ClientIDs, added "TrustyFiles" (Spike2)
CHANGED: Enhanced Client Recognization: eMulePlus-Version is correctly shown (1.1g instead of 1.1.7...) --> Thanx to Blue-
         SonicBoy from TK4!
CHANGED: Enhanced Client Recognization (ECR): little typo (wrong casing) for Hydranode fixed (thanx to madcat666)
CHANGED: Optimizer - fully implemented now, inserted some more MEMZERO instead of MEMSET, where applicable (Spike2)
CHANGED: Spooky-Mode - removed redundant "enable Spooky-Mode" (was used for enabling Spooky at Startup) and
         fixed small bug in rule-compliance (Spooky keeps being enabled, when you manually disconnect Kad)
CHANGED: TransferWindow: Right Arrow and Left Arrow expand / collapse the download again (without pressing ALT)
         (can be enabled in "Look & Feel Options") (FR from official eMule Board, Spike2) (Tag: use Arrow-keys without ALT)
CHANGED: Webcache-TrustLevel = 15 as default (from iONiX)
CHANGED: XMan's Chunk Selection Patch can be turned on / off now (Spike2, idea from Antares & nextEMF)
REMOVED: Code-fix by Maella in ListenSocket.cpp (from Xtreme Mod) - not needed, thanx to WiZaRd
REMOVED: Redundant IsBanned()-checks before banning in BaseClient.cpp (Thanx to WiZaRd)
UPDATED: CxImage-Lib updated from 5.99a to 5.99c (Spike2, from MorphXT 8.0)
UPDATED: Emulate Shareaza (Spike2)
UPDATED: LibPNG updated from 1.2.5 to 1.2.7 (Spike2, from Xtreme 4.8.2)
UPDATED: SR13-Import-Parts-feature for large file support (Spike2, partly from MorphXT)
UPDATED: Webcache for 0.47a (Spike2, greatest parts from MorphXT)


Spike2 0.6
----------
--> CODEBASE: *** !!! *** UPDATED TO eMule 0.46c *** !!! *** (FINALLY !!!!!!)
==>NOTE: Finally the Spike2 runs on 0.46c-basis !! It took a long time, but gladly it runs now - finally,
         but better late than never. I'm so happy that it works now :-)) But you would laugh why it took so
         long time and never worked... I tested min. 5 different Webcache-implementations and spend hours and 
         hours... Finally I merged to WC 2.0b1 and - the SAME ERROR. Until I recognized my own, _very little_ (and 
         quite stupid) error and realized, that ALL VERSIONS WOULD HAVE WORKED WITHOUT THIS TINY BUG !!!
         What did I learn from it ? Yes - don't use C-style-comments (e.g./*Comment*/) in Macros (e.g.
         _T("Blabla")) !!! :-) [Although I'm quite a bit angry about all the wasted time...]
ADDED  : Anti-Fake-eMule-Version (from Xtreme Mod)
ADDED  : Code-Improvements in CUint128::toBinaryString & toHexString (netF 0.3beta12, checked with Xtreme 4.5)
ADDED  : Control for showing active downloads in bold
ADDED  : Display UserHash in Status Window (from iONiX)
ADDED  : Don't show Splashscreen on old Windows to avoid crash (from Xtreme Mod)
ADDED  : Enhanced Client Recognization (Spike2): Hydranode and eMule+ are correctly identified
ADDED  : Hardlimit of 5 for eMule-Collections (from Xtreme Mod)
ADDED  : Now the SAFE_DELETE-macros from eWombat are used (taken from iONiX)
ADDED  : Recheck firewalled for Kad (by WiZaRd)
ADDED  : Recognize newer Shareaza (Spike2) - !! needed for "emulate Shareaza" !! (if we don't recognize them, 
         we can't emulate them...)
ADDED  : Reconnect Kad on IP-Change (by Xman)
ADDED  : SR13-Import-Parts-feature from MorphXT
ADDED  : "Stop this client" from Xtreme's Downloadmanager (from Xtreme Mod)
ADDED  : WiZaRd's UDPFNF-FiX (from iONiX)
BUGFIX : Avi-3k's Fix to MuleListCtrl.cpp
BUGFIX : Avi-3k's Fix to SearchListCtrl.cpp
BUGFIX : Avi-3k's Fix to Sockets.cpp (eMule sending its port twice to servers)
BUGFIX : Avi-3k's Fix to TrayDialog.cpp
BUGFIX : Avi-3k's Fix for new message log entry (believe it or not, I had the same idea and was
         looking in the code how to do it...!)
BUGFIX : Avi-3k's Fix for Shared Files "open folder"
BUGFIX : Avi-3k's Maxfilesize fix (by Avi3k, taken from Xtreme Mod)
BUGFIX : Avi-3k's Sort fix for DownloadClientsCtrl.cpp
BUGFIX : Compiled with netfinity's WS2_32.dll-fix (by netfinity)
BUGFIX : Fix for Shared Files "open folder" (by Avi3k, taken from Xtreme Mod)
BUGFIX : Reconnect to Kademlia from Pawcio
BUGFIX : Some small fixes and improvements from iONiX (thanx to Wiz + AiR) & Xtreme (thanx to Xman)
BUGFIX : Some small fixes and optimizations from FRTK-EvoStar and MorphXT
CHANGED: Adjustable File buffer size max. is now 8,5 MB instead of 15,5 MB (avoid having a whole
         chunk in the buffer)
CHANGED: Adjustable Queue size minimum is 2000 again (like in vanilla eMule)
CHANGED: MOD-Version now correctly shown in Debug-Builds, too
CHANGED: Optimizer: Enhanced CPU-Infos (by LSD, from FRTK-EvoStar)
CHANGED: Removed some username-bans to avoid banning "innocents" (Spike2)
CHANGED: Some Client-Icons (from several Mods)
CHANGED: Webcache-TrustLevel is always 99 (Spike2)
REMOVED: NeoMule 4 - ban (because it's officially allowed again...and to avoid further flamewars)
REMOVED: Wizard's Critical section mutex unlock (it was finally included in official 0.46)
REMOVED: Xman save 2nd sort criterion (not needed in 0.46c anymore)
UPDATED: BanList (again & again :-) & ULTRA-Leecher-Secure (Spike2)
UPDATED: Dazzle's faster endgame to work with 0.46c (old implementation caused the "yellow bug") 
UPDATED: Emulate eDonkey, eDonkeyHybrid, MLdonkey (Spike2)
UPDATED: Mark LowIDs by Xman (from Xtreme-Mod, added in DownloadClientsCtrl due to 0.46c-Merge)
UPDATED: SNAFU-Tags (from Xtreme Mod)
UPDATED: Webcache from 1.9a(b3) to 2.0b1 (Webcache by JP, Superlexx, Yonathan)
UPDATED: zlib from 1.1.4 to 1.2.3 (due to 0.46c-Merge)
==>NOTE: Big Thanx @WiZaRd for answering numerous questions of mine !!!!


Spike2 0.5
----------
ADDED  : Don't kill client if we are the only one complete source, it's a friend or a proxy (from MorphXT)
ADDED  : Don't kill source if it's the only one complete source, it's a friend, a proxy or not ed2kclient (from MorphXT)
ADDED  : Emulate lPhant (Spike2)
ADDED  : ENHANCED Emulate Shareaza (Spike2; thanx to Wizard for many helpfull tips and explanations, 
	 thanx to the nextEMF-team for implementing the first version in an updated way - i took this one, 
	 too and updated the emulated Shareaza-Version to v2.1.2 :-)) --> Spike2 added: newer eDonkey-
	 Protocol-Version from Shareaza is emulated as well --> Shareaza < v2.0 (i.e. v0.30) are now
         emulated too !!!
ADDED  : Filebuffer-time limit is now changeable from 1 to 10 minutes (now increasing the 
         filebuffer-size makes sense...) --> I recommend increasing this value, if you 
	 have increased the filebuffer-size (Spike2)
ADDED  : Friendhandling from all windows (by Xman, from Xtreme Mod)
ADDED  : Option to turn "80% score for non-SI-Clients" on or off (under "Upload Management")
ADDED  : Recognize newer eDonkeyHybrid-Versions (Spike2)
ADDED  : Send ModVersion in MuleInfoPacket too, not only in HelloTypePacket (from iONiX)
ADDED  : Settings for Spike2-ModLog (under "Look+Feel Options")
ADDED  : Show correct lPhant-Version (Spike2)
ADDED  : Show LowIDs by Xman (from Xtreme Mod)
ADDED  : XMans save second sort criterion for downloadlistcontrol (from Xtreme Mod)
BUGFIX : Hotfix to avoid crash in FriendListCtrl.cpp (from MorphXT)
BUGFIX : Many small fixes & optimizations (from some other mods, look at the tags)
BUGFIX : Repaired faulty Optimizer-implementation
BUGFIX : Wizard's Memleak-Fix in WebcacheClient.cpp
BUGFIX : Wizard's "Fix for closed" in ChatSelector.cpp (from iONiX)
CHANGED: Min./Max.Slots - Min.Slots-minimum is 1, maximum 200; Max.Slots-minimum is 2,maximum 250
CHANGED: ModLog - now it is possible to give the status-bar-bool here (Spike2)
CHANGED: ModLogLines - now with tags, i.e. [BANNED] (idea from nextEMF)
CHANGED: MOD_VERSION-code (now done by CurrentVersionLong, by wizard)
REMOVED: Ban Powermule, Plus Plus & Lionheart, so that the original system with setting them as "GPL-
         evildoers can work" (and added the newer Lionheart-Tags to the GPLevildoer-section)
REMOVED: Block MLdonkey-messages ("Please update...") from iONiX (Not needed anymore)
UPDATED: BanList (again...)
UPDATED: Emulate-settings (now using wizard's optimized code from iONiX 4.21)
UPDATED: Emulate mlDonkey (big thanx to Torni!!)
UPDATED: Recognizing eDonkeyHybrid-Version (from 0.46a...Spike2-Mod will soon be 
         merged to 0.46 completly - promised :-) !)
UPDATED: Wizard's AntiLeechClass to the newer version from iONiX 4.21 (by Wizard)


Spike2 0.4
----------
ADDED  : 80% score for non-SI-clients (from Xtreme Mod)
ADDED  : Anti-CreditHack (from MorphXT)
ADDED  : Find best sources by Xman (from Xtreme Mod)
ADDED  : Modstring related stuff (Splashscreen, Credits)
ADDED  : Show ModString in ClientDetails (from Xtreme Mod)
ADDED  : Variable ClientBanTime (from iONiX)
ADDED  : XMans Chunk selection patch (from Xtreme Mod)
BUGFIX : Code-fix by Maella in ListenSocket.cpp (from Xtreme Mod)
BUGFIX : Fixed an official bug in banning clients (from Xtreme Mod)
BUGFIX : Security fix by Maella in Server.cpp (from Xtreme Mod)
CHANGED: A small change in Partfile.cpp to log "Dazzle's faster endgame" events in the
         ModLog (Spike2)
CHANGED: BanThreshold for CorruptionBlackBox variable...changed uint16 to uint8
CHANGED: Filebuffer-size changed to max. 15,5 MB, Waitingqueue may be changed from 1000 - 30000
CHANGED: SNAFU...i forgot some tags...all tags from eWombat, Phoenix, SWAT and MorphXT are
         merged now + anti-CT_friendsharing with friendsharing-ID from MorphXT
CHANGED: Some small bugfixes and changes from Xtreme Mod (Thanx to Xman)
CHANGED: Some small changes in baseClient.cpp: ModLogLine@SNAFU changed, use !IsBanned
CHANGED: Spike2-Mod will not send Ban-Messages anymore
CHANGED: Splash-Screen...now you see: Speedy the cat :-)
UPDATE : Updated BanList


Spike2 0.3
----------
ADDED  : Dazzle's Faster Endgame (similiar to netfinity's dynamic block requests (?), thanx to dazzle)
ADDED  : Sorting by Mod in ClientList, Mod-Statistics (from iONiX and other mods..)
ADDED  : Wizard's AntiLeechClass: AntiModThief 2.1, AntiNickThief 2.2, Ban "Crash-Mules"
         (from iONiX)
CHANGED: IS_IDNEEDED-change in ClientList by wizard (from iONiX)
CHANGED: S.N.A.F.U. v3.1 (new Tags from eWombat, Phoenix and MorphXT)
UPDATE : Updated BanList (new Darkmule etc.)


Spike2 0.2a (HOTFIX)
--------------------
BUGFIX : Repaired faulty AUX-ports-support implementation (mea culpa)
BUGFIX : Repaired faulty ListenSocket.cpp (mea culpa, too...)
BUGFIX : Repaired Statistics-bugs
CHANGED: ULTRA-Leecher-Secure: removed eChanblard (all versions), eMulePlus and 
         NeoMule from BanList


Spike2 0.2
----------
ADDED  : AUX-ports support by lugdunummaster (from iONiX)
ADDED  : CPU-Optimizer (thanx@JohnArcher, from Xlillo)
ADDED  : Slugfiller's SpreadReask (thanx to jacko)
ADDED  : Winsock 2.2 (thanx@bobo, from eWombat)


Spike2 0.1
----------
--> CODEBASE: eMule 0.45b
ADDED  : BanThreshold for CorruptionBlackBox variable ("Security Options"-Page)
ADDED  : Create a map for fastest source adding by IP (from eF-Mod)
ADDED  : Emulate MLdonkey, emulate eDonkey, emulate eDonkeyHybrid (from iONiX)
ADDED  : Flood ask protection / "Geaiez" (by Dark, from eF-Mod)
ADDED  : Min./Max.-Slots (from iONiX)
ADDED  : ModLog (from iONiX)
ADDED  : MSS-Setting (from iONiX)
ADDED  : MTU-Setting incl. Double Sendsize (from XMan)
ADDED  : P2P-worm detection at opening eMule (from netF)
ADDED  : Preferences Side-Banner (from iONiX)
ADDED  : Small Webcache-Addon (Spike2)
ADDED  : S.N.A.F.U. v3.1 (partial) (from iONiX)
ADDED  : ULTRA-Leecher-Secure (Spike2) : bans almost all known leechers by ModString, 
         by Username or other Infos, bans GPL-breakers
ADDED  : Webcache 1.9a(b3) (BigThanx@Brano, who helped me with this) incl. 0.45b-fix by Wizard
BUGFIX : Preferences won't be saved on clicking cancel (Fix by Wizard)
BUGFIX : Wizard's Complete source display fix (from iONiX)
BUGFIX : Wizard's Critical section mutex unlock (Fix by Wizard)
BUGFIX : Wizard's Missing Buddy Check (Fix by Wizard)
BUGFIX : Wizard's PC- & WC-timeout fix (from iONiX 4.11)
BUGFIX : Wizard's URL-Client memleak fix (Fix by Wizard)
CHANGED: Credits-Thread: Bluecow is shown under "retired members", Spike is shown as Modder
CHANGED: Own Splash-Screen
CHANGED: Relax some list-cleaning actions to save CPU (by Wizard from iONiX)
CHANGED: Some GUI-Stuff (Icons, etc.)
REMOVED: Help
REMOVED: IRC
REMOVED: Scheduler
REMOVED: Wizard